//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.RecoverableErrorProvider.RecoverableErrorProvider
{
    
    
    /// <summary>
    /// Class that implements the IRecoverableErrorProvider interface through SiLA2
    /// </summary>
    public partial class RecoverableErrorProviderClient : IRecoverableErrorProvider
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.recoverableerrorprovider.v1.RecoverableErrorProvider";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public RecoverableErrorProviderClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Raises a recoverable error with the error message 'SiLA 2 recoverable error for test' after the specified duration containing the
        /// following continuation options:
        /// - Identifier = 'OptionA', Description = 'Recover the error by choosing option A',
        /// - Identifier = 'OptionB', Description = 'Recover the error by choosing option B',
        /// - Identifier = 'OptionC', Description = 'Recover the error by choosing option C'
        /// and OptionB marked as the default option.
        /// Returns the identifier of the continuation option which has been selected to handle the error.
        /// </summary>
        /// <param name="durationUntilError">The duration in seconds before the recoverable error is raised.</param>
        /// <param name="automaticExecutionTimeout">The duration in seconds after the specified default option is automatically selected (0 means no automatic execution).</param>
        public virtual Tecan.Sila2.IObservableCommand<string> RaiseRecoverableError(long durationUntilError, long automaticExecutionTimeout)
        {
            RaiseRecoverableErrorRequestDto request = new RaiseRecoverableErrorRequestDto(durationUntilError, automaticExecutionTimeout, null);
            request.Validate();
            return _channel.ExecuteObservableCommand<RaiseRecoverableErrorRequestDto, string, RaiseRecoverableErrorResponseDto>(_serviceName, "RaiseRecoverableError", request, ConvertRaiseRecoverableErrorResponse, ConvertRaiseRecoverableErrorException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of RaiseRecoverableError to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertRaiseRecoverableErrorException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Unwraps the response of the RaiseRecoverableErrorResponse command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private string ConvertRaiseRecoverableErrorResponse(RaiseRecoverableErrorResponseDto value)
        {
            return value.SelectedContinuationOption.Extract(_executionManager.DownloadBinaryStore);
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Recoverable Error Provider.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class RecoverableErrorProviderClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/RecoverableErrorProvider/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IRecoverableErrorProvider);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new RecoverableErrorProviderClient(channel, executionManager);
        }
    }
}

